/*
  Nom du Fichier: .
  Nom de classe:
  Role:
  Nombre de methodes:
  Nombre d'attributs:
  */

#ifndef MODULWINDOW_HPP
#define MODULWINDOW_HPP
#include "src/Include/Entete.hpp"
#include <QLineEdit>
#include <QRadioButton>
#include <QTableWidget>
#include <QComboBox>
#include <QHBoxLayout>
#include <QWidget>
#include <QFormLayout>
#include <QCheckBox>
#include <QGroupBox>
#include <QMessageBox>

class ModulWindow : public QWidget {
   
           Q_OBJECT

    public :
            ModulWindow(QWidget *parent=0);
            //void controlBox();
            QStringList getDataModul();
            void initialiserModul();
    
    private slots :
               void appelAjoutModul();
               void appelSuppModul();
               void callModuljHelp();

    private :
            QWidget *centralWidget; 
            QWidget *horizontalLayoutWidgetModul1;
            QWidget *horizontalLayoutWidgetspace1; 
            QHBoxLayout *horizontalLayoutModul1;
            QHBoxLayout *horizontalLayoutspace1; 
            QLineEdit *m_modulName;
            QLabel *labelModul1;//////////////////////////
            QLabel *labelInput;
            QLabel *labelOutput;
            QLabel * labelspace11;
            QComboBox *m_SpaceName;
            QWidget *horizontalLayoutWidgetspace2;
            QHBoxLayout *horizontalLayoutspace2;
            QLineEdit *m_modulInput;
             QWidget *horizontalLayoutWidgetOut;
            QHBoxLayout *horizontalLayoutOut;
            QLineEdit *m_modulOutput;
//----------------------------------------------------------
            QWidget *horizontalLayoutWidgetopera;
            QHBoxLayout *horizontalLayoutopera; 
            QLabel * labelopera;
            QComboBox *m_OperaName;
//----------------------------------------------------------
            QWidget *formLayoutWidgetInter;
            QComboBox *m_Inter;
            QComboBox *m_lopera;
            QFormLayout *formLayoutInter;
            //QCheckBox *checkBoxOutput;
//----------------------------------------------------------
            QWidget *formLayoutWidgetArray;
            QFormLayout *formLayoutArray;
            QCheckBox *arrayButton;  
//----------------------------------------------------------
            QWidget *formLayoutWidget;
            QFormLayout *formLayout;
            //QRadioButton *targetButton;
            QCheckBox *targetButton;  
             QCheckBox *checkBoxUptime;
             QCheckBox *checkBoxSeptime;
             QCheckBox *checkBoxAlltime;
//-----------------------------------------------------------
            QGroupBox *groupTarget;  
            QGroupBox *groupTargetspace1; 
            QGroupBox *groupTargetopera;
//-----------------------------------------------------------
            QWidget *horizontalLayoutWidget;
            QHBoxLayout *horizontalLayout;
            /*QRadioButton *radioButton_4;
            QRadioButton *radioButton_3;
            QRadioButton *radioButton_2;
            QWidget *verticalLayoutWidget;*/  
//------------------------------------------------------------
            QWidget *verticalLayoutWidgetBox;
            QVBoxLayout *verticalLayoutBox;
            QCheckBox *checkBoxnoward;
            QCheckBox *checkBoxtempo;
            QCheckBox *checkBoxspec;
            QCheckBox *checkBoxnetward;
            QCheckBox *checkBoxcout;
            QCheckBox *checkBoxhidjac;
            QCheckBox *checkBoxautonet;
            QCheckBox *checkBoxclonol;
            QCheckBox *checkBoxclonof;
//-----------------------------------------------------------
            QFormLayout *formLayoutmodul;
            QWidget *formLayoutWidgetmodul;
            QTableWidget *tableWidgetmodul;
            QPushButton *m_Ajoutmodul;  
//-----------------------------------------------------------
            QWidget *horizontalLayoutWidgetmodul2;
            QHBoxLayout *horizontalLayoutmodul2;
            QPushButton *pushButtonmodul3;
            QPushButton *pushButtonmodul2;
            QPushButton *pushButtonmodul1;
//------------------------------------------
            QStringList ModulData;
            QPushButton *pushButtonmodulAid;
//-----------------------------------------------------------            
	  };
#endif // MODULWINDOW_HPP
