/*
  Nom du Fichier: OperaWindow.hpp
  Nom de classe: OperaWindow
  Role:
  Nombre de methodes:
  Nombre d'attributs:
  */

#ifndef OPERAWINDOW_HPP
#define OPERAWINDOW_HPP
#include "src/Include/Entete.hpp"
#include <QTableWidget>
#include <QFormLayout>
#include <QGridLayout>
#include <QLabel>

class OperaWindow : public QWidget {

	public :
            	OperaWindow(QWidget *parent=0);

    	private :
    	
    			QLabel *m_labelOperaName;
    			QLabel *m_labelOperaType;
				QLabel *m_labelOperaD1;
				QLabel *m_labelOperaD2;
				QLabel *m_labelOperaD3;
				QLabel *m_labelOperaTraj;
				
            	QLineEdit *m_ligneNomOpera;
            	QLineEdit *m_ligneTypeOpera;
            	QLineEdit *m_ligneD1Opera;
            	QLineEdit *m_ligneD2Opera;
            	QLineEdit *m_ligneD3Opera;
            	QLineEdit *m_ligneTrajnameOpera;
		
				QPushButton *m_helpOperaButton;
				QPushButton *m_addOperaButton;
				QPushButton *m_deleteOperaButton;
		        QPushButton *m_enregOpera;
		        QPushButton *m_quitOpera;
		
			    QTableWidget *m_operaTableView;

		        QFormLayout *m_layoutOpera;
        
		        QHBoxLayout *m_layoutHOpera;
				QHBoxLayout *m_operaLayoutH1;
			    QHBoxLayout *m_operaLayoutH2;
		        QVBoxLayout *m_operaLayoutV1;

		        QGridLayout *m_operaLayoutG;

};
#endif // OPERAWINDOW_HPP
