/*
  Nom du Fichier: OptionWindow.hpp
  Nom de classe: OptionWindow
  Role:
  Nombre de methodes:
  Nombre d'attributs:
  */

#ifndef OPTIONWINDOW_HPP
#define OPTIONWINDOW_HPP
#include "src/Include/Entete.hpp"
#include <QFormLayout>
#include <QGridLayout>
#include <QComboBox>
#include <QString>
#include <QLabel>
#include <QFileDialog>
#include <QPushButton>
//#include <QStringList>
#include <QStringListModel>
#include <QListView>
#include "../../../YAOObjects/Context.hpp"

//using namespace yao;

class OptionWindow : public QWidget {
    Q_OBJECT
    public :
            	OptionWindow(QWidget *parent=0);
		QStringList getOptionData();

    private slots:

            	void enregistrerOption();
            	void ouvrirProjetExistant3();
            	void saveOptionData();
		void addOptionRow();
		void deleteOptionRow();

    private :
		QLabel *m_labelName;		

            	QComboBox  *m_comboNomOption;
            
		QPushButton *m_optionAddButton;
		QPushButton *m_optionDeleteButton;
            	QPushButton *m_enregOption;
	        QPushButton *m_quitOption;
		QPushButton *m_optionHelpButton;
            	


            	QFormLayout *m_optionLayout;
            	QHBoxLayout *m_optionLayoutH1;
		QHBoxLayout *m_optionLayoutH2;
            	QVBoxLayout *m_optionLayoutV1;
		QGridLayout *m_layoutGOption;

            	QFileDialog *projetOption;

		QString m_cheminProjetOption;
		
		QStringList filesList;	
	
		QStringListModel *filesListModele;
            	
		QListView *m_optionListView;

		yao::Context *m_theContext;
		std::vector<std::string> anVector;
		
};
#endif // OPTIONWINDOW_HPP
