//! \file    DefvalWindow.cpp
//! \brief   Implementation of the Defval window for visual_YAO.
//! \version 2009/11/09 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane & MAYOMBO Alexis.

#include "Include/InsertFCTWindow.hpp"

InsertFCTWindow::InsertFCTWindow(QWidget *parent) : QWidget(parent) { /*!< The constructor. */

    this->setWindowTitle("Directive InsertFct");           /*!< To set the window's title. */
//    this->setWindowTitle("Directive InsertFct.");

       // m_layoutH1          = new QGridLayout;  /*!< QGridLayout for the button aide */
        //m_Aidefct            = new QPushButton("De l'aide?");  /*!< QPushButton for the button aide */
       // m_layoutH1->addWidget(m_Aidefct, 0, 1);  /*!< added tableWidgetfct */
        //QGroupBox *groupAide = new QGroupBox("Definition de l'Aide");
        //groupAide->setLayout(m_layoutH1);

        formLayoutArg = new QFormLayout;                 /*!< QFormLayout, layout for argument and function name. */  
        m_ligneNomFonction = new QLineEdit;             /*!< Fonction Name of the QLineEdit. */
        argButton = new QCheckBox;                       /*!< argument of the QLineEdit. */
        formLayoutArg->addRow("nom fonction: ", m_ligneNomFonction);
        formLayoutArg->addRow("Arg: ", argButton);  
        QGroupBox *groupDetermine = new QGroupBox("Definition de InsertFct");
        groupDetermine->setLayout(formLayoutArg);             
    //-------------------------------------------------------------------------------
        tableWidgetfct = new QTableWidget(0, 2);
        tableWidgetfct->setEditTriggers(QAbstractItemView::NoEditTriggers);
        tableWidgetfct->setShowGrid(false);
        tableWidgetfct->setSelectionBehavior(QAbstractItemView::SelectRows);
   //--------------------------------------------------------------
       QStringList horizontalHeaders;
       horizontalHeaders  << "Nom Fonction" << "Argument"; /*!< displays Nom Fonction and Argument in the QTableWidget */
       tableWidgetfct->setHorizontalHeaderLabels(horizontalHeaders); /*!< displays tableWidgetfct */
       m_Ajoutfct                 = new QPushButton("Ajouter"); /*!< QPushButton for the button Ajouter */
       m_suppfct             = new QPushButton("Supprimer");   /*!< QPushButton for the button Supprimer */
       formLayoutTab = new QGridLayout;     /*!< QGridLayout for the button formLayoutTab */
       m_Aidefct            = new QPushButton("De l'aide?");  /*!< QPushButton for the button aide */
       formLayoutTab->addWidget(m_Aidefct, 1,0);  /*!< added tableWidgetfct */
       formLayoutTab->addWidget(tableWidgetfct, 0,1,5,1);  /*!< added tableWidgetfct */
       formLayoutTab -> addWidget(m_Ajoutfct, 1,2);   /*!< added m_Ajoutfct */
       formLayoutTab -> addWidget(m_suppfct, 2,2);   /*!< added m_suppfct */
       QGroupBox *groupTab = new QGroupBox("Table de valeurs"); /*!< QGroupBox for the groupTab */
       groupTab -> setLayout(formLayoutTab);  /*!< displays formLayoutTab */
    //--------------------------------------------------------------------------
       m_layoutH          = new QHBoxLayout;  /*!< QHBoxLayout for the button Enregistrer and Quitter */
       m_enreg            = new QPushButton("Enregistrer");  /*!< QPushButton for the button Enregistrer */
       m_quit             = new QPushButton("Quitter");     /*!< QPushButton for the button Quitter */
   // m_layoutH->setAlignment(Qt::AlignRight);
       m_layoutH->addWidget(m_enreg);   /*!< added button Enregistrer */
       m_layoutH->addWidget(m_quit);   /*!< added button Quitter */
      //QGroupBox *groupBouton = new QGroupBox;
       // groupBouton->setLayout(m_layoutH);

      QVBoxLayout *layoutGenerik = new QVBoxLayout;  /*!< QVBoxLayout for the groupDetrmine, groupTab and m_layout */
      layoutGenerik->addWidget(groupDetermine);   /*!< added GroupBox groupDetrmine */
      layoutGenerik->addWidget(groupTab);        /*!< added GroupBox groupTab */  
      layoutGenerik->addLayout(m_layoutH);     /*!< added GroupBox m_layoutH */
      setLayout(layoutGenerik);          /*!< displays layoutGenerik */
      
     
      connect(m_quit, SIGNAL(clicked()), this, SLOT(close())); /*!< Will be closed after a click on the button "Quit" */  
      //connect(m_quit, SIGNAL(clicked()), this, SLOT(fermerEnr()));
      connect(m_suppfct, SIGNAL(clicked()), this, SLOT(appelSuppFCT())); /*!< This slot delete a row after a click on the button "Supprimer" */
      connect(m_Ajoutfct, SIGNAL(clicked()), this, SLOT(appelAjoutfct())); /*!< To add rows in the tableview after clicking on the button "Add"*/
      connect(m_Aidefct, SIGNAL(clicked()), this, SLOT(callInsertFCTHelp()));   /*!< This slot opens */ 

}

void InsertFCTWindow::appelAjoutfct() {

   //QString espace = " space ";
   
    //------------------------
   //QString argf = "arg"; 
   QString argu;
   //-----------------------
    QString nomfct = m_ligneNomFonction->text();
    //QString espacenom = m_SpaceName->currentText();
    
 static int row = 0;
  int l = 0;

        
       
         for(int k = 0; k<nomfct.size(); k++)
      if(!((nomfct.at(k) >= QChar('a')&& nomfct.at(k) <= QChar('z')) || (nomfct.at(k) >= QChar('A')&& nomfct.at(k) <= QChar('Z'))//--------
         || (nomfct.at(k) >= QChar('0')&& nomfct.at(k) <= QChar('9')) || (nomfct.at(k) == QChar('_')))) 
    {
        QMessageBox::critical(this, "Erreur", "Veuillez entrer un nom d'espace associe correcte");
        return; // Arrêt de la méthode 
    }

          for(int j = 0; j<nomfct.size(); j++)
{
         if (argButton->isChecked())
    {
        argu = " arg ";
    }
      else {
            argu = "  ";
          }
}
             
             if (l >= 0)
{
            
      tableWidgetfct->setItem(row, 0, new QTableWidgetItem(m_ligneNomFonction->text()));
      tableWidgetfct->setItem(row, 1, new QTableWidgetItem(argu));
      
         
     fctData.push_back(m_ligneNomFonction->text() + argu);
          
       
    row++;
} 
  initialiserChampsfct();
    }
   /****************************************************************************************/
void InsertFCTWindow::appelSuppFCT() {

                 tableWidgetfct->removeRow(tableWidgetfct->currentRow());

               }
/****************************************************************************************************************************/
QStringList InsertFCTWindow::getDataFCT() {

    
     return fctData;
}
//****************************************************************************************/

void InsertFCTWindow::initialiserChampsfct() {
                 
	m_ligneNomFonction->clear();
        
}
//**************************************************************************************************************************

/*void InsertFCTWindow::fermerEnr()
{
     // if ((m_quit->pressed()) && (m_enreg->pressed()))
      if(m_enreg->isChecked())
    {
        close();
    }
    else {
        QMessageBox::critical(this, "Erreur", "Voullez vous enregistrer avant de Quitter !!!");
        return; // Arrêt de la méthode 
    }

}

*/  
void InsertFCTWindow::callInsertFCTHelp() {

  QMessageBox::about(this, tr("Aide sur la directive insert_fct."),("<p> Elle sert a définir les fonctions à , "
                              "insérer dans l'application yao "
                              "étant qu'une trajectoire pourra être porteuse de plusieurs espaces. <p>Les parametres à "
                              "préciser sont les suivants : <br>traj   trajname  type  nbuptime  [offtime dtime]  nbsteptime"
                              "<br> <a href=\"help/traj_aide.html\">lien HTML Cliquez ici SVP !</a>"));

}