#ifndef FILESVIEWER_HPP
#define FILESVIEWER_HPP

#include <QDialog>

class QDirModel;
class QPushButton;
class QTreeView;

class FilesViewer : public QDialog
{
    Q_OBJECT

public:
    FilesViewer(QWidget *parent = 0);

public slots:
    void createDirectory();
    void remove();

private:
    QTreeView *vueFichiers;
    
    public:
    QDirModel *modeleFichiers;
    QPushButton *mkdirButton;
    QPushButton *removeButton;
    QPushButton *boutonActualiser;

};

#endif //ARBOFICHIERS_HPP
