//! \file    MainWindowController.cpp
//! \brief   Implementation of the MainWindowController window for visual_YAO.
//! \version 2009/11/09 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane & MAYOMBO Alexis.


#include "Include/MainWindowController.hpp"

//! \class MainWindowController & MainWindowController::getInstance() 
//! \brief Implementation of the MainWindow controller for visual_YAO.


using namespace std;

/****************************************************************************************************************************************/
//MainWindowController::MainWindowController() {

    //for(vector<string>::iterator it = m_hat->getTheHeaderList().begin(); it != m_hat->getTheHeaderList().end(); it++)
        //setTheHeaderList("test push_back");
    //np = new NewProjectWindow;
    //setProjectNameInMWC("test.h");//np->getNewProjectName());
    //m_defval = new DefvalWindow;
    //m_projectNameInMWC = np->getNewProjectName();
    //m_hat->setLocalProjectName(m_projectNameInMWC);
    //m_hat = new HatNameWindow("test");
    //setProjectNameInMWC();

//}
/********************************************************* getInstance() ****************************************************************/
MainWindowController & MainWindowController::getInstance() {

	static MainWindowController instance;
	
	return instance;
}
/********************************************************** setProjectNameInMWC(string name ) *******************************************/
void MainWindowController::setProjectNameInMWC(string name ) {

    m_projectNameInMWC = name;
}

/*********************************************************** getProjectNameFromMWC() ****************************************************/
string MainWindowController::getProjectNameFromMWC() {

  return m_projectNameInMWC;
}

/************************************************************ setDefval() ***************************************************************/
void MainWindowController::setDefval() {

    //m_defval = new DefvalWindow(&m_theHeaderList);
}

/************************************************************  getDefval() **************************************************************/
DefvalWindow *MainWindowController::getDefval() {
        //m_defval = new DefvalWindow();
    return m_defval = new DefvalWindow;
}

/****************************************************************************************************************************************/
//void MainWindowController::setHatName(std::string hat) {

//}

/************************************************************ getHatName() **************************************************************/
HatNameWindow *MainWindowController::getHatName() {


    return new HatNameWindow(getProjectNameFromMWC());

}

/************************************************************ getOption() ***************************************************************/
OptionWindow *MainWindowController::getOption() {

   return m_option = new OptionWindow;

}

/************************************************************ getTraj() *****************************************************************/
TrajWindow *MainWindowController::getTraj() {

   return m_traj = new TrajWindow(&m_theTrajectoryTable);

}
/************************************************************* getSpace() ***************************************************************/

SpaceWindow *MainWindowController::getSpace() {

   return m_space = new SpaceWindow();
}

/************************************************************* getOpera() ***************************************************************/

OperaWindow *MainWindowController::getOpera() {

   return m_opera = new OperaWindow;
}

/************************************************************** getNetward() ************************************************************/

NetwardWindow *MainWindowController::getNetward() {

    return m_netward = new NetwardWindow;
}

/************************************************************** getModul() **************************************************************/

ModulWindow *MainWindowController::getModul() {

    return m_modul = new ModulWindow;
}

/*************************************************************** getCtin() **************************************************************/

CtinWindow *MainWindowController::getCtin() {

    return m_ctin = new CtinWindow;
}

/**************************************************************** getOrder() ************************************************************/

OrderWindow *MainWindowController::getOrder() {

    return m_order = new OrderWindow;
}
/**************************************************************** getInsertFCT() ********************************************************/

InsertFCTWindow *MainWindowController::getInsertFCT() {

    return m_insertFCT = new InsertFCTWindow;
}


/**************************************************************** getNewProjectInstance() ***********************************************/
NewProjectWindow *MainWindowController::getNewProjectInstance() {

   // m_projectName = np->name;
  return this->getNP();
}

/**************************************************************** getNP() ***************************************************************/
NewProjectWindow *MainWindowController::getNP() {

    return np;
}

/***************************************************************** getSpaceController() *************************************************/
SpaceController MainWindowController::getSpaceController()
{
	
	SpaceController m_spc = SpaceController::getInstance();
    return m_spc;
}

/****************************************************************************************************************************************/
//void MainWindowController::setNewProjectName(std::string newProject) {

//}

/****************************************************************************************************************************************/
//std::string MainWindowController::getNewProjectName() {
	
//	return
//}

/*************************************************** setTheHeaderList(string theHeaderListString) ***************************************/
void MainWindowController::setTheHeaderList(string theHeaderListString) {

    m_theHeaderList.push_back(theHeaderListString);
}

/*************************************************** getTheHeaderList() *****************************************************************/
std::vector<std::string> MainWindowController::getTheHeaderList() {

    //setTheHeaderList("");
  //std::vector<std::string>m_theHeaderList m_theHeaderList;
   m_theHeaderList.push_back("test push_back");
    return m_theHeaderList;
}

/************************************************* setFileListController(string fileController) *****************************************/
void MainWindowController::setFileListController(string fileController) {

    m_hat->setFileList(fileController);
}

/************************************************* getTheTrajectoryTable() **************************************************************/
yao::Table<yao::Trajectory> MainWindowController::getTheTrajectoryTable(){

    return m_theTrajectoryTable;

}

/****************************************************************************************************************************************/



/****************************************************************************************************************************************/
